﻿using System;
using System.ComponentModel;
using System.IO;
using ClotureSiadForms.Renderer;
using Foundation;
using ClotureSiadForms.iOS.Renderer;
using WebKit;
using Xamarin.Forms;
using Xamarin.Forms.Platform.iOS;

[assembly: ExportRenderer(typeof(CustomWebView), typeof(HybridWebViewRenderer))]
namespace ClotureSiadForms.iOS.Renderer
{
    public class HybridWebViewRenderer : WkWebViewRenderer, IWKScriptMessageHandler
    {
        public HybridWebViewRenderer()
        {
        }

        protected override void OnElementChanged(VisualElementChangedEventArgs e)
        {
            base.OnElementChanged(e);

            if (e.NewElement != null)
            {
                var nd= new NavigationDelegate();

                CustomWebView webview=e.NewElement as CustomWebView;
                nd.js= webview.js;

                this.NavigationDelegate = nd;
            }

        }

        public void DidReceiveScriptMessage(WKUserContentController userContentController, WKScriptMessage message)
        {
            Console.WriteLine("----------------------------------------");
        }
    }

    public class NavigationDelegate : WKNavigationDelegate
    {
        public string js="";

        public override void DecidePolicy(WKWebView webView, WKNavigationAction navigationAction, WKWebpagePreferences preferences, Action<WKNavigationActionPolicy, WKWebpagePreferences> decisionHandler)
        {
            //  base.DecidePolicy(webView, navigationAction, preferences, decisionHandler);

            decisionHandler.Invoke(WKNavigationActionPolicy.Allow, preferences);

        }

        public override void DidFailNavigation(WKWebView webView, WKNavigation navigation, NSError error)
        {
            //base.DidFailNavigation(webView, navigation, error);

            Console.WriteLine("*******************************");

        }

        public override void DidFinishNavigation(WKWebView webView, WKNavigation navigation)
        {
            //base.DidFinishNavigation(webView, navigation);
            webView.EvaluateJavaScriptAsync(js);

            Console.WriteLine("+++++++++++++++++++++++++++++++");
        }
    }
}