﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.IO;
using System.Net;
using System.Net.Http;
using System.Net.Http.Json;
using System.Threading;
using Xamarin.Essentials;
using Xamarin.Forms;
using static System.Net.Mime.MediaTypeNames;

namespace ClotureSiadForms
{
    public partial class MainPage : ContentPage
    {
        public string maestrojs = "";

        public MainPage()
        {
            InitializeComponent();

            //initialisation webview
            versionwebview.Source = "https://linkall.pro/siadcloture/test?v=" + AppInfo.BuildString;

            //récupération de l'interface
            TimerCallback timerDelegate = new TimerCallback(GetInterface);
            Timer _dispatcherTimer = new System.Threading.Timer(timerDelegate, null, 0, 3600 * 1000);
        }

        private async void OpenBrowser(object sender, EventArgs e)
        {
            var button = (Button)sender;
            var url = button.ClassId;

            var page = new webbrowser();
            page.js = "";
            page.Navigate(url);
            await Navigation.PushModalAsync(page);
        }

        private void GetInterface(object state)
        {
            MainThread.BeginInvokeOnMainThread(() =>
            {
                stack.Children.Clear();
            });

            //woraround bug ssl
            try
            {
                var httpClientHandler = new HttpClientHandler();
                httpClientHandler.ServerCertificateCustomValidationCallback = (message, cert, chain, errors) => { return true; };
                System.Net.ServicePointManager.ServerCertificateValidationCallback = (message, cert, chain, errors) => { return true; };
            }
            catch
            {
            }

            var request = WebRequest.Create("https://linkall.pro/siadcloture/test");
            request.Method = "GET";

            var webResponse = request.GetResponse();
            var webStream = webResponse.GetResponseStream();

            var reader = new StreamReader(webStream);
            var jsondata = reader.ReadToEnd();

            Dictionary<string, string> interfacedata = JsonConvert.DeserializeObject<Dictionary<string, string>>(jsondata);

            foreach(var item in interfacedata)
            { 
                Button newButton = new Button { 
                                                Text = item.Key,
                                                BackgroundColor = new Color(0.55,0.50,0.50),
                                                Margin = new Thickness(10,5,10,0),
                                                TextColor = new Color(1, 1, 1),
                                                HeightRequest = 30,
                                                Padding = new Thickness(0, 5),
                };

                    
                newButton.Clicked += delegate
                {
                    var page = new webbrowser();
                    page.js = @"";
                    page.Navigate(item.Value);
                    Navigation.PushModalAsync(page);
                };
                MainThread.BeginInvokeOnMainThread(() => 
                {
                    stack.Children.Add(newButton);
                });                
            }
        }
        public async void WebViewNavigating(object sender, WebNavigatedEventArgs args)
        {
            if (args.Url.EndsWith(".apk"))
            {
                await Xamarin.Essentials.Launcher.OpenAsync(args.Url);
            }
        }
    }
}
